# ==============================================================================
# sgxRSM.tcl --
#
#	sgxRSM: SoftGuards eXtension for Resource Standard Metrics
#
# Copyright (c) 1999 by T&E Soft, Stefan G. R. Finzel <finzel@osn.de>.
# All rights reserved.
#
# See the file "license.terms" for information on usage and redistribution of
# this file, and for a DISCLAIMER OF ALL WARRANTIES. 
#
# RCS: @(#) $Id: sgxRSM.tcl,v 1.2 2001/08/27 08:49:50 fis Exp $
# ==============================================================================

# sgxRSM configuration:
#   tests        tests to perform (do not alter, internal use only!)
#   summary      0/1=de-/activate summary for all procs
#   LKM,proc     0/1=de-/activate language keyword metrics (calls) per procedure
#   LKM,total    0/1=de-/activate language keyword metrics (calls) summary
#   rules,mean   list of rules to apply for mean value of al procs
#   rules,proc   list of rules to apply for each procedure
#   rules,total  list of rules to apply for summary of all procs
global sgxRSM

set sgxRSM(summary) 1
set sgxRSM(LKM,proc) 0
set sgxRSM(LKM,total) 1

# each element of a rule list is a list itself, containing 
#   an interpretable expression and a descriptive text.
set sgxRSM(rules,proc) {
    { {$rsm_proc(eLOC)  <=  250}       {eLOC: maximum limit} }
    { {$rsm_proc(FPM)   <=    5}       {FPM : maximum limit} }
    { {$rsm_proc(LOC)   <=  350}       {LOC : maximum limit} }
}

set sgxRSM(rules,total) {
    { {$rsm_total(CCM)  <=   50}       {CCM : maximum limit} }
    { {$rsm_total(eLOC) <= 2500}       {eLOC: maximum limit} }
    { {$rsm_total(LOC)  <= 2000}       {LOC : maximum limit} }
}

set sgxRSM(rules,mean) {
    { {$rsm_mean(eLOC)  <=  100}       {eLOC: maximum limit} }
    { {$rsm_mean(FPM)   <=    3}       {FPM : maximum limit} }
    { {$rsm_mean(FRPM)  <=    2}       {FRPM: maximum limit} }
    { {$rsm_mean(LOC)   <=  150}       {LOC : maximum limit} }
    { {$rsm_mean(SCUM)   >   10}       {SCUM: minimum limit} }
}

# testing rules
#    { {INVALID RULE}                   {the rule is invalid}     }
#    { {0}                              {everything is invalid}   }
#    { {$sgxRSM(xyz)}                   {the variable is invalid} }

return 0
